#!/bin/sh

# script to produce index.html from a short hardwired intro and the first-line
# comments in each example

gen_table()
{
for n in *
do
	if test -d $n
	then
		desc=`(cd $n && head -n 1 *.c) | grep "[/][*].*xample" | sed "s@/[*] *@@;s@ *[*]/@@;s/^[Ee]xample: *//"`
		case "$desc"
		in
			"") ;;
			$1) echo "<tr><td><a href=\"$n\">$n</a><td>$desc";;
		esac
	fi
done
}


(
echo '
<html><body>
<H1> Genvector example programs </H1>
Below is a list of example code available. Each tries to demonstrate a
different use case. They mostly differ in vector type, configuration and
instantiation. The actual set of operations they execute are mostly the same:
the usual things an application may want to do with dynamic arrays or strings.
<p>
<table border=1 cellspacing=0>
'

# list examples in the "right" order (simpler/common ones first)
gen_table "*standard dynamic string*"
gen_table "*standard vector type*"
gen_table "*custom vector type*"

echo '
</table></body></html>
'
) > index.html

