/* Make sure holes are always initialized, even if they are not newly allocated */
#include "common.h"

int main()
{
	ovt_t a;
	obj_t o;
	int n;

	auto_init(a);
	print_arr("init ", &a);

	for(n = 0; n < 5; n++) {
		oprintf(&o, "init=%d", n);
		ovt_append(&a, o);
	}
	print_arr("init", &a);


	/* grow and fill up some void to make sure destructors are ran properly */
	for(n = 8; n >= 5; n--) {
		oprintf(&o, "fill=%d", n);
		ovt_set(&a, n, o);
	}
	print_arr("fill", &a);


	/* overwrite some existing records */
	for(n = 2; n <= 7; n++) {
		oprintf(&o, "ovrw=%d", n);
		ovt_set(&a, n, o);
	}
	print_arr("ovrw", &a);

	/* partial shrink to see if all destructors ran */
	ovt_resize(&a, 4);
	print_arr("shrn", &a);

	auto_uninit(&a);
}
